#ifndef _CHUNK_H_
#define _CHUNK_H_

#include "buffer.h"

typedef struct {
	/* ok, this one is tricky:
	 * 
	 * MEM_CHUNK
	 *   b: the chunk it self
	 * FILE_CHUNK
	 *   b: a buffer for the filename
	 */
	buffer *b;
	
	/* only used for FILE_CHUNK*/
	off_t offset;
	off_t length;
	
	/* how many bytes are already written */
	off_t written;
	
	enum { UNUSED_CHUNK, MEM_CHUNK, FILE_CHUNK } type;
} chunk;

typedef struct {
	chunk **chunk;
	
	size_t size;
	size_t used;
} chunkset;

chunkset *chunk_init();
int chunk_append_file(chunkset *c, buffer *fn, off_t offset, off_t len);
int chunk_append_mem(chunkset *c, const char *mem, size_t len);
int chunk_append_buffer(chunkset *c, buffer *mem);
int chunk_prepend_buffer(chunkset *c, buffer *mem);

buffer * chunk_get_append_buffer(chunkset *c);
buffer * chunk_get_prepend_buffer(chunkset *c);

size_t chunkset_length(chunkset *c);
size_t chunkset_written(chunkset *c);
void chunk_free(chunkset *c);

#endif
